<?php

// +---------------------------------------------------------------------------+
// | WebTracker by Matthai, http://www.ljudmila.org/matej                      |
// | Copyright (C) 2002 Matej Kovacic                                          |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// +---------------------------------------------------------------------------+

// +---------------------------------------------------------------------------+
// | CONFIGURATION                                                             |
// +---------------------------------------------------------------------------+

// Do not save users using these browsers into database
$forbiden_browsers = array ("TridentSpider", "ASPSeek", "Googlebot", "ia_archiver", "Openbot");

// +---------------------------------------------------------------------------+

// Connect to database
$dbhost = "localhost";
$dbuser = "";
$dbpass = "";
$database = "matthai";
$dbconnect = mysql_connect($dbhost, $dbuser, $dbpass) or die("");
$dbselect = mysql_select_db($database, $dbconnect);

// +---------------------------------------------------------------------------+

// Cookie lives one year...
$cookie_life = 365*24*3600;

// +---------------------------------------------------------------------------+
// | END OF CONFIGURATION                                                      |
// +---------------------------------------------------------------------------+


function check_browser ($item,$key,$users_browser) {
  global $dontsave;

  // Search for a complete string
  // ============================
  // if ($item == $users_browser) {
  //   $dontsave = 1;
  // }

  // Search for a substring only
  // ===========================
  if (ereg ($item, $users_browser)) {
    $dontsave = 1;
  }
}

// Check which browser is in use
$dontsave = 0;
reset ($forbiden_browsers);
@array_walk ($forbiden_browsers, 'check_browser', $HTTP_USER_AGENT);

// Set special header which enables web spiders to recognize you are using WebTracker system
header('WebTracker: 1.0');

// If it is not forbiden browser, proceed
if ($dontsave == 0) {

  // Set that session_id expires when user closes the browser
  ini_set("session.cookie_lifetime", "0");

  // Get date and time
  $datetime = date("Y-m-d H:i:s");

  // Initialize session
  session_start();

  // Register session and set number of session visits variable to 1
  if (!session_is_registered('sess_visits')) {
      session_register('sess_visits');
      $sess_visits = 1;
  }
  else {  // session already registered
    $sess_visits++;
  }

  // Get session ID
  $sessid = session_id();

  // Register cookieID and sessionID only if there is new session started!

  if ($sess_visits == 1) {
    // If user already has a cookie, and CountID is set, get it,
    if ($HTTP_COOKIE_VARS['CountID']) {
      $cookie_globid = $HTTP_COOKIE_VARS['CountID'];
      $cookieid = "";

      // Extend cookie life
      Setcookie("CountID",$cookie_globid,time()+$cookie_life,"/");

      // Check if cookie is saved in database and increase the counter
      $sql = "SELECT cookieid, num_visits FROM wt_cookieident WHERE cookieid = '$cookie_globid'";
      if(!mysql_query($sql)) {
         # echo("SQL error (select cookie)!<br>");
      }
      else {  // no error...
        $result = mysql_query($sql);
        $myfield = mysql_fetch_array($result);
        $cookieid = $myfield['cookieid'];
      }

      // Is cookie retrieved from user in our database?

      if ($cookieid=="") {  //cookie not found in the database!!!
        $num_visits = 1;
        $sql = "INSERT INTO wt_cookieident SET cookieid = '$cookie_globid', num_visits = '$num_visits', firstlogindatetime = '$datetime', cookieerror = '1'";
        if(!mysql_query($sql)) {
           # echo("SQL error (insert bad cookie)!<br>");
        }
      }
      else {  // cookieid not empty
        // Increase number of visits counter and update database
        $num_visits = $myfield['num_visits'];
        $num_visits++;
        $sql = "UPDATE wt_cookieident SET num_visits = '$num_visits' WHERE cookieid = '$cookie_globid'";
        if(!mysql_query($sql)) {
           # echo("SQL error (update number of visits)!<br>");
        }
      }
    }  // end of if user already has a cookie...

    // user do not have a cookie, so set it as session ID
    else {
      Setcookie("CountID",$sessid,time()+$cookie_life,"/");
      $cookie_globid = $sessid;
      $num_visits = 1;
      // Save new cookieid into database
      $sql = "INSERT INTO wt_cookieident SET cookieid = '$cookie_globid', num_visits = '$num_visits', firstlogindatetime = '$datetime', cookieerror = '0'";
      if(!mysql_query($sql)) {
         # echo("SQL error (insert first cookie)!<br>");
      }
    }  // end of user do not have a cookie

    // CookieID and number of visits are OK now!
    // Now session should be saved to the database.

    $mysessid = "";
    // Check if session is already saved in database (That should never
    // happen! However, it seems PHP has some problems with this.)
    $sql = "SELECT sessid, sessappear FROM wt_sessionident WHERE sessid = '$sessid'";
    if(!mysql_query($sql)) {
       # echo("SQL error (select session ID in the database)!<br>");
    }
    else {  // no error...
      $result = mysql_query($sql);
      $myfield = mysql_fetch_array($result);
      $mysessid = $myfield['sessid'];
    }

    if ($sessid==$mysessid) {  // Is there double session ID?
      // Increase counter of double session ID appearing and write it to the table
      $sessappear==$myfield['sessappear']++;
      $sql = "UPDATE wt_sessionident SET sessappear = '$sessappear' WHERE sessid = '$sessid'";
      if(!mysql_query($sql)) {
         # echo("SQL error (update session ID double appear counter)!<br>");
      }
    }
    else {  // Session is not doubled...
      // Save session, IP, hostname, referer, browser, etc. into database
      $wtreferer = addslashes($HTTP_REFERER);
      $wtuagent = addslashes($HTTP_USER_AGENT);
      $wtacclan = addslashes($HTTP_ACCEPT_LANGUAGE);
      $sql = "INSERT INTO wt_sessionident SET sessid = '$sessid', cookieid = '$cookie_globid', IP = '$REMOTE_ADDR', host = '$REMOTE_HOST', referer = '$wtreferer', browser = '$wtuagent', acclang = '$wtacclan', sessionstartdatetime = '$datetime', sessappear = '1'";
      if(!mysql_query($sql)) {
  	   # echo("SQL error (insert session)!<br>");
      }

      // Register cookie session and set session variable
      if (!session_is_registered('cookieident')) {
        session_register('cookieident');
        $cookieident = $cookie_globid;
      }
    }
  } // end of $sess_visits == 1


  // In next session visit check if user accepted the cookie
  if ($sess_visits == 2) {
    if ($HTTP_COOKIE_VARS['CountID'] == $cookieident) {
       # echo "OK, user acepts cookies.";
    }
    else {
      $sql = "UPDATE wt_cookieident SET nocookie = '1' WHERE cookieid = '$cookieident'";
      if(!mysql_query($sql)) {
         # echo("SQL error (update user do not accept cookies)!<br>");
      }
    }
  }

  ////

  // Save info about visited location
  $wtlocation = addslashes($REQUEST_URI);
  $sql = "INSERT INTO wt_moving SET sessid = '$sessid', location = '$wtlocation', accessdatetime = '$datetime'";
  if(!mysql_query($sql)) {
     # echo("SQL error (insert location)!<br>");
  }

} // End of if forbiden browser...



else {  // if forbiden browser, save it to robots table

  // Cut robot name because of SQL table field length
  $therobotname = addslashes(substr($HTTP_USER_AGENT, 0, 80));
  $robotname = "";

  // Check if robot is saved in database and increase the counter
  $sql = "SELECT robotname, robotcounter FROM wt_robots WHERE robotname = '$therobotname'";
  if(!mysql_query($sql)) {
     # echo("SQL error (select robot)!<br>");
  }
  else {  // no error...
    $result = mysql_query($sql);
    $myfield = mysql_fetch_array($result);
    $robotname = $myfield['robotname'];
  }

  // Is robot name in our database?
  if ($robotname=="") {  // robotname not found in the database!!!
    $sql = "INSERT INTO wt_robots SET robotname = '$therobotname', firstIP = '$REMOTE_ADDR', firsthost = '$REMOTE_HOST', robotcounter = '1'";
    if(!mysql_query($sql)) {
      # echo("SQL error (insert robot name)!<br>");
    }
  } // end of robotname not found in the database!!!

  else {  // robotname found in the database
    // Increase number of visits counter and update database
    $robotcounter = $myfield['robotcounter'];
    $robotcounter++;
    $sql = "UPDATE wt_robots SET robotcounter = '$robotcounter' WHERE robotname = '$therobotname'";
    if(!mysql_query($sql)) {
      # echo("SQL error (update robot counter)!<br>");
    }
  } // end of robotname found in the database

} // end of if forbiden browser

?>