# WebTracker by Matthai
# ---------------------

#
# Table structure for table 'wt_cookieident'
#

CREATE TABLE wt_cookieident (
  cookieid varchar(32) default NULL,
  num_visits mediumint(5) default NULL,
  firstlogindatetime datetime default NULL,
  nocookie tinyint default NULL,
  cookieerror tinyint default NULL
) TYPE=MyISAM;


#
# Table structure for table 'wt_sessionident'
#

CREATE TABLE wt_sessionident (
  sessid varchar(32) default NULL,
  cookieid varchar(32) default NULL,
  IP varchar(15) default NULL,
  host varchar(80) default NULL,
  referer varchar(150) default NULL,
  browser varchar(80) default NULL,
  acclang varchar(40) default NULL,
  sessionstartdatetime datetime default NULL,
  sessappear tinyint default NULL  
) TYPE=MyISAM;


#
# Table structure for table 'wt_moving'
#

CREATE TABLE wt_moving (
  sessid varchar(32) default NULL,
  location varchar(150) default NULL,
  accessdatetime datetime default NULL
) TYPE=MyISAM;


#
# Table structure for table 'wt_robots'
#

CREATE TABLE wt_robots (
  robotname varchar(80) default NULL,
  firstIP varchar(15) default NULL,
  firsthost varchar(80) default NULL,
  robotcounter mediumint(6) default NULL
) TYPE=MyISAM;